/*
   Class Name:

      CCamera.

   Created by:

      Allen Sherrod (Programming Ace of www.UltimateGameProgramming.com).

   Description:

      This class represents a camera in a 3D scene.
*/


#ifndef CCAMERA_H
#define CCAMERA_H

#include<math.h>                          // Math header that allows us to use cos() and sin().

#define UP              0.03f             // Forward speed.
#define DOWN            -0.03f            // Backward speed.
#define LEFT            -0.03f            // Left speed.
#define RIGHT           0.03f             // Right speed.

#define GET_COS(a, b)   a = (float)cos(b) // Get the cos angle of b and store it in a.
#define GET_SINE(a, b)  a = (float)sin(b) // Get the sine angle of b and store it in a.


class CCamera
{
   public:
      CCamera();                                      // Constructor.

      void SetCamera(float x, float y, float z,       // Set the camera's position.
                     float xv, float yv, float zv,
                     float xu, float yu, float zu);

      void MoveCamera(float direction);               // Move the camera forwards and backwards.
      void RotateCamera(float AngleDir, float xSpeed, // Rotate the camera around a point.
                        float ySpeed, float zSpeed);

      float xPos, yPos, zPos;                         // Camera position.
      float xView, yView, zView;                      // Look at position.
      float xUp, yUp, zUp;                            // Up direction.
};

#endif


// Copyright September 2004
// All Rights Reserved!
// Allen Sherrod
// ProgrammingAce@UltimateGameProgramming.com
// www.UltimateGameProgramming.com